using Entities;
using Model;
using Shared;

namespace EFMappers;

public static class HeartRateMapper
{
    private static GenericMapper<HeartRate, HeartRateEntity> _mapper = new GenericMapper<HeartRate, HeartRateEntity>();
    // ! RESET
    // ? Quand on fait appel au reset ?
    // * Apres des saves changing ou rollback.
    public static void Reset()
    {
        _mapper.Reset();
    }
    public static HeartRate ToModel(this HeartRateEntity entity)
    {
        // return entity.ToModel();
        return entity.ToT(_mapper, heartRate => new HeartRate (
            entity.IdHeartRate,
            entity.Altitude,
            entity.Time,
            entity.Temperature,
            entity.Bpm,
            entity.Longitude,
            entity.Latitude,
            entity.ActivityId
        )
            // ! regarder a ce que le model est bien les relation comme l'EF
        , (heartRate, entity) => heartRate.ActivityId = entity.ActivityId);

    }
    // dictionnaire;


    public static HeartRateEntity? ToEntity(this HeartRate model)
    {
        // return model.ToEntity();
        return model.ToU(_mapper, heartRateEntity => new HeartRateEntity
        {
            IdHeartRate = model.Id,
            Altitude = model.Altitude,
            Time = model.Time,
            Temperature = model.Temperature,
            Bpm = model.Bpm,
            Longitude = model.Longitude,
            Latitude = model.Latitude,
            ActivityId = model.ActivityId
        }
        , (heartRate, entity) => entity.ActivityId = heartRate.ActivityId
            // ! regarder a ce que le model est bien les relation comme l'EF
        );
    }

    public static IEnumerable<HeartRate?> ToModels(this IEnumerable<HeartRateEntity> entities)
        => entities.Select(hr => hr.ToModel());

    public static IEnumerable<HeartRateEntity?> ToEntities(this IEnumerable<HeartRate> models)
        => models.Select(hr => hr.ToEntity());
}