using Model;

public class DataSource
{
    public int Id { get; set; }
    public string Type { get; set; }
    public string Model { get; set; }
    public float Precision { get; set; }
    public ICollection<Activity> Activities { get; set; } = new List<Activity>();
    public ICollection<Athlete> Athletes { get; set; } = new List<Athlete>();
    public DataSource(int id, string type, string model, float precision, ICollection<Activity> activities, ICollection<Athlete> athletes)
    {
        Id = id;
        Type = type;
        Model = model;
        Precision = precision;
        Activities = activities;
        Athletes = athletes;
    }
    public DataSource(){}

    public DataSource(int id, string type, string model, float precision)
    {
        Id = id;
        Type = type;
        Model = model;
        Precision = precision;
    }

    public override string ToString()
    {
        return $"DataSource #{Id}: {Type} {Model} with a precision of {Precision}";
    }
}