namespace Model;

public class HeartRate {
    public int Id { get; set; }
    public double Altitude { get; set; }
    public TimeOnly Time { get; set; }
    public float Temperature { get; set; }
    public int Bpm { get; set; }
    public float Longitude { get; set; }
    public float Latitude { get; set; }
    public int ActivityId { get; set; }
    public HeartRate(int id, double altitude, TimeOnly time, float temperature, int bpm, float longitude, float latitude, int activityId)
    {
        Id = id;
        Altitude = altitude;
        Time = time;
        Temperature = temperature;
        Bpm = bpm;
        Longitude = longitude;
        Latitude = latitude;
        ActivityId = activityId;
    }
    public HeartRate(){}

    public override string ToString()
    {
        return $"HeartRate #{Id}: {Bpm} bpm at {Time:HH:mm:ss} with a temperature of {Temperature}°C" +
               $" and an altitude of {Altitude}m at {Longitude}°E and {Latitude}°N";
    }
}