﻿namespace UnitTestsEntities;
using Xunit;
using System.Linq;
using Entities;
using Microsoft.EntityFrameworkCore;

public class NotificationEntityTests
{
    [Fact]
    public void Add_Notification_Success()
    {
        var sender = new AthleteEntity
        {
            Username = "sender_user",
            LastName = "Sender",
            FirstName = "User",
            Email = "sender.user@example.com",
            Sexe = "M",
            Length = 170.0,
            Weight = 70.0f,
            Password = "senderpassword",
            DateOfBirth = new DateOnly(1990, 1, 1),
            IsCoach = false
        };

        var notification = new NotificationEntity
        {
            Message = "Test notification",
            Date = DateTime.Now,
            Statut = false,
            Urgence = "High",
            Sender = sender
        };

        /*
        using (var context = new StubbedContext(options))
        {
            context.Database.EnsureCreated();
            context.Athletes.Add(sender);
            context.Notifications.Add(notification);
            context.SaveChanges();
        }

        using (var context = new StubbedContext(options))
        {
            var savedNotification = context.Notifications.First();
            Assert.NotNull(savedNotification);
            Assert.Equal("Test notification", savedNotification.Message);
        }*/
    }

    [Fact]
    public void Update_Notification_Success()
    {
        var sender = new AthleteEntity
        {
            Username = "sender_user",
            LastName = "Sender",
            FirstName = "User",
            Email = "sender.user@example.com",
            Sexe = "M",
            Length = 170.0,
            Weight = 70.0f,
            Password = "senderpassword",
            DateOfBirth = new DateOnly(1990, 1, 1),
            IsCoach = false
        };

        var notification = new NotificationEntity
        {
            Message = "Test notification",
            Date = DateTime.Now,
            Statut = false,
            Urgence = "High",
            Sender = sender
        };

        /*
        using (var context = new StubbedContext(options))
        {
            context.Database.EnsureCreated();
            context.Athletes.Add(sender);
            context.Notifications.Add(notification);
            context.SaveChanges();
        }

        using (var context = new StubbedContext(options))
        {
            var savedNotification = context.Notifications.First();
            savedNotification.Message = "Updated message";
            context.SaveChanges();
        }

        using (var context = new StubbedContext(options))
        {
            var updatedNotification = context.Notifications.First();
            Assert.NotNull(updatedNotification);
            Assert.Equal("Updated message", updatedNotification.Message);
        }*/
    }

    [Fact]
    public void Delete_Notification_Success()
    {
        var sender = new AthleteEntity
        {
            Username = "sender_user",
            LastName = "Sender",
            FirstName = "User",
            Email = "sender.user@example.com",
            Sexe = "M",
            Length = 170.0,
            Weight = 70.0f,
            Password = "senderpassword",
            DateOfBirth = new DateOnly(1990, 1, 1),
            IsCoach = false
        };

        var notification = new NotificationEntity
        {
            Message = "Test notification",
            Date = DateTime.Now,
            Statut = false,
            Urgence = "High",
            Sender = sender
        };

        /*
        using (var context = new StubbedContext(options))
        {
            context.Database.EnsureCreated();
            context.Athletes.Add(sender);
            context.Notifications.Add(notification);
            context.SaveChanges();
        }

        using (var context = new StubbedContext(options))
        {
            var savedNotification = context.Notifications.First();
            context.Notifications.Remove(savedNotification);
            context.SaveChanges();
        }

        using (var context = new StubbedContext(options))
        {
            var deletedNotification = context.Notifications.FirstOrDefault();
            Assert.Null(deletedNotification);
        }*/
    }
}

