﻿namespace UnitTestsEntities;
using Xunit;
using System.Linq;
using Entities;
using Microsoft.EntityFrameworkCore;


public class StatisticEntityTests
{
    [Fact]
    public void Add_Statistic_Success()
    {
        var athlete = new AthleteEntity
        {
            Username = "athlete_user",
            LastName = "Athlete",
            FirstName = "User",
            Email = "athlete.user@example.com",
            Sexe = "M",
            Length = 170.0,
            Weight = 70.0f,
            Password = "athletepassword",
            DateOfBirth = new DateOnly(1990, 1, 1),
            IsCoach = false
        };

        var statistic = new StatisticEntity
        {
            Weight = 75.0f,
            AverageHeartRate = 150.0,
            MaximumHeartRate = 180.0,
            AverageCaloriesBurned = 500.0,
            Date = new DateOnly(2024, 3, 15),
            Athlete = athlete
        };

        /*
        using (var context = new StubbedContext(options))
        {
            context.Database.EnsureCreated();
            context.Athletes.Add(athlete);
            context.Statistics.Add(statistic);
            context.SaveChanges();
        }

        using (var context = new StubbedContext(options))
        {
            var savedStatistic = context.Statistics.First();
            Assert.NotNull(savedStatistic);
            Assert.Equal(75.0f, savedStatistic.Weight);
        }*/
    }

    [Fact]
    public void Update_Statistic_Success()
    {
        var athlete = new AthleteEntity
        {
            Username = "athlete_user",
            LastName = "Athlete",
            FirstName = "User",
            Email = "athlete.user@example.com",
            Sexe = "M",
            Length = 170.0,
            Weight = 70.0f,
            Password = "athletepassword",
            DateOfBirth = new DateOnly(1990, 1, 1),
            IsCoach = false
        };

        var statistic = new StatisticEntity
        {
            Weight = 75.0f,
            AverageHeartRate = 150.0,
            MaximumHeartRate = 180.0,
            AverageCaloriesBurned = 500.0,
            Date = new DateOnly(2024, 3, 15),
            Athlete = athlete
        };

        /*
        using (var context = new StubbedContext(options))
        {
            context.Database.EnsureCreated();
            context.Athletes.Add(athlete);
            context.Statistics.Add(statistic);
            context.SaveChanges();
        }

        using (var context = new StubbedContext(options))
        {
            var savedStatistic = context.Statistics.First();
            savedStatistic.Weight = 80.0f;
            context.SaveChanges();
        }

        using (var context = new StubbedContext(options))
        {
            var updatedStatistic = context.Statistics.First();
            Assert.NotNull(updatedStatistic);
            Assert.Equal(80.0f, updatedStatistic.Weight);
        }*/
    }

    [Fact]
    public void Delete_Statistic_Success()
    {
        var athlete = new AthleteEntity
        {
            Username = "athlete_user",
            LastName = "Athlete",
            FirstName = "User",
            Email = "athlete.user@example.com",
            Sexe = "M",
            Length = 170.0,
            Weight = 70.0f,
            Password = "athletepassword",
            DateOfBirth = new DateOnly(1990, 1, 1),
            IsCoach = false
        };

        var statistic = new StatisticEntity
        {
            Weight = 75.0f,
            AverageHeartRate = 150.0,
            MaximumHeartRate = 180.0,
            AverageCaloriesBurned = 500.0,
            Date = new DateOnly(2024, 3, 15),
            Athlete = athlete
        };

        /*
        using (var context = new StubbedContext(options))
        {
            context.Database.EnsureCreated();
            context.Athletes.Add(athlete);
            context.Statistics.Add(statistic);
            context.SaveChanges();
        }

        using (var context = new StubbedContext(options))
        {
            var savedStatistic = context.Statistics.First();
            context.Statistics.Remove(savedStatistic);
            context.SaveChanges();
        }

        using (var context = new StubbedContext(options))
        {
            var deletedStatistic = context.Statistics.FirstOrDefault();
            Assert.Null(deletedStatistic);
        }*/
    }
}

